<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <el-form v-loading="formLoading" :model="formData" label-width="80px">
      <el-form-item label="名称" prop="configName">
        <el-input v-model="formData.configName" disabled />
      </el-form-item>
      <el-form-item label="值" prop="configValue">
        <el-input v-model="formData.configValue" />
      </el-form-item>
      <el-form-item label="json" prop="configJson">
        <el-input v-model="formData.configJson" type="textarea" />
      </el-form-item>
      <el-form-item label="备注" prop="configDesc">
        <el-input v-model="formData.configDesc" placeholder="请输入内容" type="textarea" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="SystemDictTypeForm" setup>
import { updateConfig } from '@/api/system/dict/config'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({})

/** 打开弹窗 */
const open = async (val) => {
  dialogVisible.value = true
  dialogTitle.value = '修改配置项'
  // 修改时，设置数据
  formData.value = { ...val }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 提交请求
  formLoading.value = true
  try {
    const params = {
      driverTypeId: formData.value.driverTypeId,
      configKey: formData.value.configKey,
      configValue: formData.value.configValue,
      configJson: formData.value.configJson,
      configName: formData.value.configName,
      configDesc: formData.value.configDesc
    }
    await updateConfig(params)
    message.success(t('common.updateSuccess'))
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}
</script>
